# Ensoniq ES5506 instrument editor

the ES5506 instrument editor contains three tabs: Sample, ES5506 and Macros.

## Sample

for sample settings, see [the Sample instrument editor](sample.md).

## ES5506

ES5506 contains a filter, which is somewhat configurable.
there's also a hardware envelope, but it's probably most useful for smoothing.

you may use this tab to set up ES5506-specific parameters:

- **Filter Mode**: sets filter mode.
  - **HP/K2, HP/K2**: run high-pass twice using filter K2.
  - **HP/K2, LP/K1**: run high-pass using filter K2, and then low-pass using filter K1.
  - **LP/K2, LP/K2**: run low-pass twice using filter K2.
  - **LP/K2, LP/K1**: run low-pass using filter K2, and then again using filter K1.
- **Filter K1**: set coefficient 1 (K1). effectively controls cutoff.
- **Filter K2**: set coefficient 2 (K2). effectively controls cutoff.
- **Envelope count**: set length of hardware envelope (it's very short even at highest value).
- **Left Volume Ramp**: how much to change left volume on every envelope step.
- **Right Volume Ramp**: how much to change right volume on every envelope step.
- **Filter K1 Ramp**: how much to change filter K1 every envelope step.
- **Filter K2 Ramp**: how much to change filter K2 on every envelope step.
- **K1 Ramp Slowdown**: increases length of K1 ramp.
- **K2 Ramp Slowdown**: increases length of K2 ramp.

## Macros

- **Volume**: volume sequence.
- **Arpeggio**: pitch sequence.
- **Filter Mode**: sets filter mode.
- **Panning (left)**: output level for left channel.
- **Panning (right)**: output level for right channel.
- **Pitch**: fine pitch.
- **Phase Reset**: trigger restart of waveform.
- **Filter K1**: K1 sequence.
- **Filter K2**: K2 sequence.
- **Outputs**: ES5506 has 6 stereo output (total 12). select which pair of outputs to use.
- **Control**: reverse/pause sequence.
